commit 2db200ea8a63dd580b47002d9464afc7a7b5e90e
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Mon Feb 6 20:59:51 2023 +0100

    Fortran: ASSOCIATE variables should not be TREE_STATIC [PR95107]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/95107
            * trans-decl.c (gfc_finish_var_decl): With -fno-automatic, do not
            make ASSOCIATE variables TREE_STATIC.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/95107
            * gfortran.dg/save_7.f90: New test.
    
    (cherry picked from commit c36f3da534e7f411c5bc48c5b6b660e238167480)

diff --git a/gcc/fortran/trans-decl.c b/gcc/fortran/trans-decl.c
index bb72eb6731d..b616db34c3f 100644
--- a/gcc/fortran/trans-decl.c
+++ b/gcc/fortran/trans-decl.c
@@ -737,6 +737,7 @@ gfc_finish_var_decl (tree decl, gfc_symbol * sym)
   /* Keep variables larger than max-stack-var-size off stack.  */
   if (!(sym->ns->proc_name && sym->ns->proc_name->attr.recursive)
       && !sym->attr.automatic
+      && !sym->attr.associate_var
       && sym->attr.save != SAVE_EXPLICIT
       && sym->attr.save != SAVE_IMPLICIT
       && INTEGER_CST_P (DECL_SIZE_UNIT (decl))
diff --git a/gcc/testsuite/gfortran.dg/save_7.f90 b/gcc/testsuite/gfortran.dg/save_7.f90
new file mode 100644
index 00000000000..dfbef12bec0
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/save_7.f90
@@ -0,0 +1,17 @@
+! { dg-do compile }
+! { dg-options "-O2 -fno-automatic" }
+!
+! PR fortran/95107 - do not make associate variables TREE_STATIC
+! Contributed by G.Steinmetz
+
+program p
+  type t
+     real, pointer :: a => null()
+  end type
+  type t2
+     type(t) :: b(1)
+  end type
+  type(t2), save :: x
+  associate (y => x%b)
+  end associate
+end

